NEED-DETERIORATED-APT-HERE